//Written by Jiangjian Xiao

#ifndef __IMG_H__
#define __IMG_H__

#include "define.h"

struct PgmImage;
struct PpmImage;


struct Rgb
{
	uchar b;
	uchar g;
	uchar r;

	Rgb(){};

	Rgb(uchar _r,uchar _g,uchar _b)
	{
		b=_b;
		g=_g;
		r=_r;
	};

	void Set(uchar _r,uchar _g,uchar _b)
	{
		b=_b;
		g=_g;
		r=_r;
	};
};

struct Point
{
	int x;
	int y;

	Point()
	{
	};

	Point(int _x,int _y)
	{
		x=_x;
		y=_y;
	}

	void Set(int _x,int _y)
	{
		x=_x;
		y=_y;
	}
};

//Image is a structure for PGM format;
struct PgmImage
{
	int colorLevel;
	int row;
	int col;
	uchar** img;			// for pgm using

	PgmImage(int _row,int _col);
	PgmImage(int _row,int _col, uchar color);
	PgmImage(PgmImage* _img);
	PgmImage(char* filename);
	PgmImage();
	~PgmImage();

	void Edge(float ht,float lt,float sigma);
	void VerticalEdge(float ht,float lt,float sigma);
	void Connect(int r, int c, float lt, float** Im2, float** Im4);
	void WritePGM(char* filename);
	void ReadPGM(char* filename);
	void Copy(PgmImage* _img);
	void Clear();
	void Clear(uchar color);

	void DrawPoint(int x, int y);
	void DrawCross(int x, int y, uchar color);
	void WritePixel(int x, int y, uchar color);
};


struct PpmImage
{
	int colorLevel;
	int row;
	int col;
	uchar** img;			// for pgm using
	PpmImage(int _row,int _col);
	PpmImage(int _row,int _col, Rgb &color) ;
	PpmImage(PpmImage* _img);
	PpmImage(char* filename);
	PpmImage();
	~PpmImage();

	void WritePPM(char* filename);
	void ReadPPM(char* filename);
	void Copy(PpmImage* _img);

	void Clear();
	void Clear(Rgb &color);
	void WritePixel(int x, int y, Rgb &color);
	void DrawPoint(int x, int y, Rgb &color);
	void Ppm2Pgm(PgmImage *pgm);
};


#endif